# Modules ---------------------------------------------------------------

from tkinter import *

#from PIL import Image, ImageTk   # pip install pillow

from random import randint

# Fonctions ------------------



def creer_fenetre() :

    fenetre = Tk()

    fenetre.title("Jeu du Casse brique")

    return fenetre



def creer_widgets() :

    zone_graphique = Canvas(fenetre, width=1000, height=600 , bg= 'black')

    zone_graphique.grid()

    return zone_graphique



#balle----------



def  creerBalle():

    balle = zone_graphique.create_oval(500,300,520,320, fill = "white")

    return balle



def go(event):

    global stop 

    stop = True

    start()

# FONCTION PRINCIPALE DU PROGRAMME

def start():

    global dx,dy

    global stop

    a0,b0,a1,b1 = zone_graphique.coords(balle)

    x0,y0,x1,y1 = zone_graphique.coords(plateforme)

    c0,d0,c1,d1 = zone_graphique.coords(len(brique))

    #collision des briques

    for i in range(30):

        c0,d0,c1,d1 = zone_graphique.coords(brique[i])

        if a0<c1 and a1>c0 and b0<d1 :   

            dy = -dy  #rebond de la balle

            dy = dy + 0.5 #augmente la vitesse de la balle à chaque brique détruite

            zone_graphique.coords(brique[i],2000,700,2001,701) #sortir les briques du jeu

    #collision Plateforme/balle

    if a0>x0 and a1<x1 and b1>y0 :      

        dy = -dy  

    #PERDU

    if b1 >550:      

        stop = False 

        perdu = zone_graphique.create_text(500,300,text="Perdu", fill="white",font=100)

    #START

    if a1 + dx > 1000 or a0 + dx <0 : 

        dx = -dx

    if b1 + dy > 600 or b0 + dy <0 : 

        dy = -dy

    zone_graphique.coords(balle, a0+dx, b0+dy, a1+dx, b1+dy)

    if stop:

        fenetre.after(20,start)



#plateforme-----



def creerPlateforme(l,h):

    x = 475

    y = 520

    plateforme = zone_graphique.create_rectangle(x,y,x+l,y+h, fill = "orange")

    

    return plateforme

#mouvement

def deplace_droite(event):

    global Rx

    x0,y0,x1,y1 = zone_graphique.coords(plateforme)

    if x0 > 0 and x1 < 1000-Rx:

        zone_graphique.coords(plateforme,x0+Rx,y0,x1+Rx,y1)

    

    

def deplace_gauche(event):

    global Rx

    x0,y0,x1,y1 = zone_graphique.coords(plateforme)

    if x0 > 0 + Rx and x1 < 1000: 

        zone_graphique.coords(plateforme,x0-Rx,y0,x1-Rx,y1)



#brique

        

def brique():

    brique= []

    largeur  = 100

    for i in range(10):

        brique.append(zone_graphique.create_rectangle(i*largeur,5,largeur+i*largeur,40,fill = "orange")) #Ligne1

        brique.append(zone_graphique.create_rectangle(i*largeur,80,largeur+i*largeur,40,fill = "orange"))#Ligne2

        brique.append(zone_graphique.create_rectangle(i*largeur,110,largeur+i*largeur,80,fill = "orange"))#Ligne3

    return brique



#indication

def indication():

    texte1 = zone_graphique.create_text(120,550,text="appuyez sur clique droit pour commencer", fill="white")

    texte2 = zone_graphique.create_text(130,575,text="utiliser les flèches directionelles pour bouger", fill="white")

#main----------

Rx = 20 #vélocité de la plateforme



dx = 5 #vélocité de la balle

dy = 5 #vélocité de la balle

stop = True

fenetre = creer_fenetre()

zone_graphique = creer_widgets()

balle = creerBalle()

brique = brique()

texte1 = indication()

texte2 = indication()

plateforme = creerPlateforme(100,10) #dimension plateforme

fenetre.bind("<Right>",deplace_droite)

fenetre.bind("<Left>",deplace_gauche)

zone_graphique.bind("<ButtonPress-3>",go)

fenetre.mainloop()

